"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    makeUseApiMutation: function() {
        return makeUseApiMutation;
    },
    makeUseApiQuery: function() {
        return makeUseApiQuery;
    }
});
var _request = require("./request");
function _object_without_properties(source, excluded) {
    if (source == null) return {};
    var target = _object_without_properties_loose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _object_without_properties_loose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function makeUseApiMutation(method, useMutation, buildTimeBaseUrl) {
    var mutateFunction = (0, _request.makeApiRequestFunction)(method, buildTimeBaseUrl);
    return function(route, options) {
        var result = useMutation([
            route
        ], function(variables) {
            return mutateFunction(route, variables, options === null || options === void 0 ? void 0 : options.fetchOptions);
        }, options);
        return result;
    };
}
function makeUseApiQuery(method, useQuery, buildTimeBaseUrl) {
    var getterFunction = (0, _request.makeApiRequestFunction)(method, buildTimeBaseUrl);
    return function(route, variables, options) {
        var _ref = options || {}, fetchOptions = _ref.fetchOptions, rest = _object_without_properties(_ref, [
            "fetchOptions"
        ]);
        var queryKey = (0, _request.buildUrl)(route, variables === null || variables === void 0 ? void 0 : variables.params, buildTimeBaseUrl);
        var result = useQuery([
            queryKey
        ], function() {
            return getterFunction(route, variables, fetchOptions);
        }, rest);
        return result;
    };
}
